# Pre-defined Marker Types

The Resources plug-in comes with the pre-defined marker types listed below. Each has a corresponding constant declaration defining its id on the type `org.eclipse.core.resources.IMarker`.

- org.eclipse.core.resources.marker
- org.eclipse.core.resources.problemmarker
- org.eclipse.core.resources.taskmarker
- org.eclipse.core.resources.bookmark
- org.eclipse.core.resources.textmarker

### Marker

See: `org.eclipse.core.resources.IMarker.MARKER`
The pre-defined marker type `org.eclipse.core.resources.marker` is the root of the marker type hierarchy. All markers should inherit (directly or indirectly) from this type.

The marker marker type has the following characteristics:

transient
  true
super
  no super types
attributes
  no attributes

## Problem Marker

See: `org.eclipse.core.resources.IMarker.PROBLEM`
The pre-defined marker type `org.eclipse.core.resources.problemmarker` is used to represent problems in resources. Typically this will be a compilation error, bad movie frames, etc..

The problemmarker marker type has the following characteristics:

transient
  false
super
  `org.eclipse.core.resources.marker`
attributes

severity

A number from the set of error, warning and info severities defined by the plaform

message
  An arbitary string describing the nature of the marker (e.g., a name for a bookmark or task). The content and form of this attribute is not specified or interpreted by the platform.
location

The location is a human-readable string which can be used to distinguish between markers on a resource. As such it should be concise and aimed at users. The content and form of this attribute is not specified or interpreted by the platform.

## Task Marker

See: `org.eclipse.core.resources.IMarker.TASK`
The pre-defined marker type `org.eclipse.core.resources.taskmarker` is used to represent user todo items and the like.

The taskmarker marker type has the following characteristics:

transient
  false
super
  `org.eclipse.core.resources.marker`
attributes

priority

A number from the set of high, normal and low priorities defined by the plaform.

message
  An arbitary string describing the nature of the marker (e.g., a name for a bookmark or task). The content and form of this attribute is not specified or interpreted by the platform.
done

A boolean value indicating whether or not a the marker (e.g., a task) is considered done.

## Bookmark

See: `org.eclipse.core.resources.IMarker.BOOKMARK`
The pre-defined marker type `org.eclipse.core.resources.bookmark` is used to remember interesting resources or places in resources. This may be as the result of a user action or some sort of automated search.

The bookmark marker type has the following characteristics:

transient
  false
super
  `org.eclipse.core.resources.marker`
attributes

message
  An arbitary string describing the nature of the marker (e.g., a name for a bookmark or task). The content and form of this attribute is not specified or interpreted by the platform.
location

The location is a human-readable string which can be used to distinguish between markers on a resource. As such it should be concise and aimed at users. The content and form of this attribute is not specified or interpreted by the platform.

## Text Marker

See: `org.eclipse.core.resources.IMarker.TEXT`
The pre-defined marker type `org.eclipse.core.resources.textmarker` is used to indicate a particular location in a text file. Typically this is used to refine another marker type and produce a type of marker which is fully locatable. For example, a Java problem marker would also be a text marker as it would need to locate the problem within Java source files.

The textmarker marker type has the following characteristics:

transient
  true
super
  `org.eclipse.core.resources.marker`
attributes

charStart
  An integer value indicating where a text marker starts. This attribute is zero-relative and inclusive.
charEnd

An integer value indicating where a text marker ends. This attribute is zero-relative and inclusive.

lineNumber

An integer value indicating the line number for a text marker. This attribute is 1-relative.